Learn how easy it is to sync an existing GitHub or Google Code repo to a SourceForge project! See Demo

Close

#21 Subtitle support for Samsung devices

Unstable (example)
closed-accepted
Jin
None
5
2014-05-06
2010-06-09
Marcin Jurkowski
No

Modern Samsung TVs are able to play movie with subtitles from DLNA server, but subtitles require some non-standard extensions of DLNA protocol. What it means: using standard DLNA server you can watch movie, though without subtitles.
This patch adds some of Samsung proprietary extensions, just enough for subtitles to work.

What it does:
1. When listing a folder, append non-standard <sec:CaptionInfoEx> tag to each video item. This tag servers only as a hint for Samsung client to check for subtitle download URL using HTTP HEAD method.
2. Before playing movie, Samsung device issues HTTP HEAD request on video item. In FileRequestHandler::get_info method we look for subtitle file and return it's download URL in CaptionInfo.sec header.
3. The device retrieves subtitles from URL provided in CaptionInfo.sec header. This is handled thanks to existing blind request feature.

Related

Patches: #21

Discussion

    • Fernando
      Fernando
      2014-01-26

      Guys, I downloaded the patch but i don´t know how to install. Can anyone help me?

       
  • Diego Aguirre
    Diego Aguirre
    2010-09-12

    Nice job... Can you see if was same functionality for videos with 2 or more audio streams?

     
  • Diego Aguirre
    Diego Aguirre
    2010-10-14

    Marcin Jurkowski,
    With this patch, subtitle works well on samsung TV, but i'm unable to disable subtitles by remote control.
    With Samsung PC Share Manager (windows app) i can disable subtitles, change font size etc...

     
  • Matthew Liong
    Matthew Liong
    2011-02-08

    Hi, I have applied the patch without error. But it doesn't work. I use Wireshark to capture all the packets until playback, cannot find any matching field called "CaptionInfo" at the packet content. Am I missing anything? Thanks in advance.

    Regards,

     
  • Hello r32190sf

    I didn't make it clear, but Samsung support is disabled by default. You need to enable it in configuration file.
    In your config.xml find element <protocolInfo/> and add attribute "samsung-hack" with value "yes". After modification it should look like this:
    <protocolInfo extend="yes" samsung-hack="yes"/>

    You should also configure custom HTTP header like this:
    <add header="contentFeatures.dlna.org: DLNA.ORG_OP=01;DLNA.ORG_CI=0;DLNA.ORG_FLAGS=017000 00000000000000000000000000" />
    I can't remember now if it's neccesary for subtitles to work, but it solves a couple of problems with Samsung DLNA player.
    Hope it helps.

    Regards

     
  • Matthew Liong
    Matthew Liong
    2011-02-09

    Thanks for your prompt reply. It works! One comment: There should be a space between ...yes" samsung-hack... at the config.xml

    Regards,

     
  • I've just tested this with the latest version of mediatomb, and it works like a charm. No problems applying the patch, and it seems to work as advertised.

    Any chance this might be applied to the development version and included in the next release?

     
  • Jin
    Jin
    2013-12-25

    • status: open --> closed-accepted
    • assigned_to: Jin
    • Group: --> Unstable (example)
     
  • Jin
    Jin
    2013-12-25

    Thanks, applied.

     
    • It's nice to see that something is going on again.

      I must warn you however that since this patch was submitted a bunch of new devices has been released to the market. They're known to have some issues with MT. Even with uri fix some devices still won't play movies.

      I'll try to take a closer look on that and try to improve support for newer Samsung devices in January.

       
  • maniootek
    maniootek
    2014-05-06

    how can I apply this patch to my debaian headless server with mediatomb?

     
    • Hi

      You don't need to apply this patch. Although there's no release with this
      functionality yet, it's already commited to git repository.

      Simply checkout and compile source code (see
      http://mediatomb.cc/pages/download#dev_code). Remember that Samsung
      extension must be extension must be explicitly enabled in config file by
      setting "samsung-hack" attribute of "protocolInfo" to "yes".

      kr

      On Tue, May 6, 2014 at 7:51 PM, maniootek maniootek@users.sf.net wrote:

      how can I apply this patch to my debaian headless server with mediatomb?

      Status: closed-accepted
      Group: Unstable (example)

      Created: Wed Jun 09, 2010 10:35 PM UTC by Marcin Jurkowski
      Last Updated: Wed Dec 25, 2013 12:01 AM UTC
      Owner: Jin

      Modern Samsung TVs are able to play movie with subtitles from DLNA server,
      but subtitles require some non-standard extensions of DLNA protocol. What
      it means: using standard DLNA server you can watch movie, though without
      subtitles.
      This patch adds some of Samsung proprietary extensions, just enough for
      subtitles to work.

      What it does:
      1. When listing a folder, append non-standard <sec:CaptionInfoEx> tag to
      each video item. This tag servers only as a hint for Samsung client to
      check for subtitle download URL using HTTP HEAD method.
      2. Before playing movie, Samsung device issues HTTP HEAD request on video
      item. In FileRequestHandler::get_info method we look for subtitle file and
      return it's download URL in CaptionInfo.sec header.
      3. The device retrieves subtitles from URL provided in CaptionInfo.sec
      header. This is handled thanks to existing blind request feature.


      Sent from sourceforge.net because you indicated interest in
      https://sourceforge.net/p/mediatomb/patches/21/

      To unsubscribe from further messages, please visit
      https://sourceforge.net/auth/subscriptions/

       

      Related

      Patches: #21

      Attachments
      • maniootek
        maniootek
        2014-05-07

        Would you be able to provide some more info step by step how to do that as
        I am not that familiar with compiling source code. Please note that i use
        headless debian. Thank you in advance
        7 maj 2014 16:41 "Marcin Jurkowski" marcin1j@users.sf.net napisał(a):

        Hi

        You don't need to apply this patch. Although there's no release with this
        functionality yet, it's already commited to git repository.

        Simply checkout and compile source code (see
        http://mediatomb.cc/pages/download#dev_code). Remember that Samsung
        extension must be extension must be explicitly enabled in config file by
        setting "samsung-hack" attribute of "protocolInfo" to "yes".

        kr

        On Tue, May 6, 2014 at 7:51 PM, maniootek maniootek@users.sf.net wrote:

        how can I apply this patch to my debaian headless server with mediatomb?

        Status: closed-accepted
        Group: Unstable (example)

        Created: Wed Jun 09, 2010 10:35 PM UTC by Marcin Jurkowski
        Last Updated: Wed Dec 25, 2013 12:01 AM UTC
        Owner: Jin

        Modern Samsung TVs are able to play movie with subtitles from DLNA server,
        but subtitles require some non-standard extensions of DLNA protocol. What
        it means: using standard DLNA server you can watch movie, though without
        subtitles.
        This patch adds some of Samsung proprietary extensions, just enough for
        subtitles to work.

        What it does:
        1. When listing a folder, append non-standard tag to
        each video item. This tag servers only as a hint for Samsung client to
        check for subtitle download URL using HTTP HEAD method.
        2. Before playing movie, Samsung device issues HTTP HEAD request on video
        item. In FileRequestHandler::get_info method we look for subtitle file and
        return it's download URL in CaptionInfo.sec header.
        3. The device retrieves subtitles from URL provided in CaptionInfo.sec
        header. This is handled thanks to existing blind request feature.


        Sent from sourceforge.net because you indicated interest in
        https://sourceforge.net/p/mediatomb/patches/21/

        To unsubscribe from further messages, please visit
        https://sourceforge.net/auth/subscriptions/


        Status: closed-accepted
        Group: Unstable (example)
        Created: Wed Jun 09, 2010 10:35 PM UTC by Marcin Jurkowski
        Last Updated: Tue May 06, 2014 05:51 PM UTC
        Owner: Jin

        Modern Samsung TVs are able to play movie with subtitles from DLNA server,
        but subtitles require some non-standard extensions of DLNA protocol. What
        it means: using standard DLNA server you can watch movie, though without
        subtitles.
        This patch adds some of Samsung proprietary extensions, just enough for
        subtitles to work.

        What it does:
        1. When listing a folder, append non-standard <sec:CaptionInfoEx> tag to
        each video item. This tag servers only as a hint for Samsung client to
        check for subtitle download URL using HTTP HEAD method.
        2. Before playing movie, Samsung device issues HTTP HEAD request on video
        item. In FileRequestHandler::get_info method we look for subtitle file and
        return it's download URL in CaptionInfo.sec header.
        3. The device retrieves subtitles from URL provided in CaptionInfo.sec
        header. This is handled thanks to existing blind request feature.


        Sent from sourceforge.net because you indicated interest in
        https://sourceforge.net/p/mediatomb/patches/21/

        To unsubscribe from further messages, please visit
        https://sourceforge.net/auth/subscriptions/

         

        Related

        Patches: #21